local BCT = LibStub("AceAddon-3.0"):GetAddon("BCT")

BCT.BUFF = 1
BCT.DEBUFF = 2
BCT.ENCHANT = 3
BCT.OTHER = 4

BCT.CONSUMABLE = 1.1
BCT.WORLDBUFF = 1.2
BCT.PLAYERBUFF = 1.3
BCT.PERSONALS = 1.4
BCT.HOLIDAY = 1.5

BCT.HEAD = 3.1
BCT.SHOULDERS = 3.2
BCT.LEGS = 3.3
BCT.FEET = 3.4
BCT.WRIST = 3.5
BCT.HANDS = 3.6
BCT.BACK = 3.7
BCT.MH = 3.8
BCT.OH = 3.9

BCT.TALENT = 4.1
BCT.CLASS = 4.2
BCT.PROFESSION = 4.3

BCT.BLACKLISTED = true
BCT.WHITELISTED = false
BCT.SHOW = true
BCT.HIDE = false
BCT.COUNT = true
BCT.IGNORE = false
BCT.LISTED = true
BCT.UNLISTED = false
BCT.RESERVED = true
BCT.UNRESERVED = false

BCT.templates = {
	["WarrDPS/Rogue Basic"] = {23894,29131,10157,23028,27841,27681,15359,16237,2479,9910,10060,2970,132,11743,131,546,5697,10170,29166,552,14253,18264,7353,25918,25899,25890,19854,19979,20914,10278,24740,24712,24713,24735,24736,24723,24711,24710,24732,24708,24709},
	["WarrDPS/Rogue + Heals"] = {23894,29131,10157,23028,27841,27681,15359,16237,2479,9910,10060,2970,132,11743,131,546,5697,10170,29166,552,14253,18264,7353,25918,25899,25890,19854,19979,20914,10278,24740,24712,24713,24735,24736,24723,24711,24710,24732,24708,24709,10929,9841,27637,10901,552,14253,29203,16237,27874,22009,28810,25899,25890,20914,19979,10174},
	["Mana User Basic"] = {24740,24712,24713,24735,24736,24723,24711,24710,24732,24708,24709,12179,12174,9910,131,546,5697,2970,132,11743,11551,19838,20914,19979,25916,25890,25899,15359,552,14253,16237,7353,20236,2479},
}

local auras_default = {
	[BCT.BUFF] = { -- ListName, DisplayName, Shown/Hidden, Count/Ignore, Blacklist/Whitelist, BuffType, Listed, Reserved
		-- Holiday
		[26522] = {GetSpellInfo(26522), "Lunar Fortune", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[6724] = {GetSpellInfo(6724), "Light of Elune", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[26393] = {GetSpellInfo(26393), "Elune's Blessing", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27572] = {GetSpellInfo(27572), "Smitten", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[29332] = {GetSpellInfo(29332), "Fire-toasted Bun", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24705] = {GetSpellInfo(24705), "Invocation of the Wickerman", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27669] = {GetSpellInfo(27669), "Orgrimmar Gift of Friendship (Agi)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27671] = {GetSpellInfo(27671), "Undercity Gift of Friendship (Int)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27670] = {GetSpellInfo(27670), "Thunder Bluff Gift of Friendship (Stam)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27665] = {GetSpellInfo(27665), "Ironforge Gift of Friendship (Stam)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27664] = {GetSpellInfo(27664), "Stormwind Gift of Friendship (Int)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27666] = {GetSpellInfo(27666), "Darnassus Gift of Friendship (Agi)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27722] = {GetSpellInfo(27722), "Sweet Surprise", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27721] = {GetSpellInfo(27721), "Very Berry Cream", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27720] = {GetSpellInfo(27720), "Buttermilk Delight", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[27723] = {GetSpellInfo(27723), "Dark Desire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23768] = {GetSpellInfo(23768), "Sayge's Dark Fortune of Damage", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23769] = {GetSpellInfo(23769), "Sayge's Dark Fortune of Resistance", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23767] = {GetSpellInfo(23767), "Sayge's Dark Fortune of Armor", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23738] = {GetSpellInfo(23738), "Sayge's Dark Fortune of Spirit", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23766] = {GetSpellInfo(23766), "Sayge's Dark Fortune of Intelligence", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23737] = {GetSpellInfo(23737), "Sayge's Dark Fortune of Stamina", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23735] = {GetSpellInfo(23735), "Sayge's Dark Fortune of Strength", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[23736] = {GetSpellInfo(23736), "Sayge's Dark Fortune of Agility", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24740] = {"Hallowed Wand - Wisp", "Hallowed Wand - Wisp", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24712] = {"Hallowed Wand - Leper Gnome (Male)", "Hallowed Wand - Leper Gnome (Male)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24713] = {"Hallowed Wand - Leper Gnome (Female)", "Hallowed Wand - Leper Gnome (Female)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24735] = {"Hallowed Wand - Ghost (Male)", "Hallowed Wand - Ghost (Male)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24736] = {"Hallowed Wand - Ghost (Female)", "Hallowed Wand - Ghost (Female)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24723] = {"Hallowed Wand - Skeleton", "Hallowed Wand - Skeleton", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24711] = {"Hallowed Wand - Ninja (Male)", "Hallowed Wand - Ninja (Male)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24710] = {"Hallowed Wand - Ninja (Female)", "Hallowed Wand - Ninja (Female)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24732] = {"Hallowed Wand - Bat", "Hallowed Wand - Bat", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24708] = {"Hallowed Wand - Pirate (Male)", "Hallowed Wand - Pirate (Male)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		[24709] = {"Hallowed Wand - Pirate (Female)", "Hallowed Wand - Pirate (Female)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.HOLIDAY, BCT.UNLISTED, BCT.UNRESERVED},
		-- Consumable
		[17626] = {"Flask of the Titans", "Flask of the Titans", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17627] = {"Flask of Distilled Wisdom", "Flask of Distilled Wisdom", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17628] = {"Flask of Supreme Power", "Flask of Supreme Power", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17629] = {"Flask of Chromatic Resistance", "Flask of Chromatic Resistance", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17624] = {"Flask of Petrification", "Flask of Petrification", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16322] = {"Juju Flurry", "Juju Flurry", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16329] = {"Juju Might", "Juju Might", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16323] = {"Juju Power", "Juju Power", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[10667] = {"R.O.I.D.S.", "R.O.I.D.S.", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[10668] = {"Lung Juice Cocktail", "Lung Juice Cocktail", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[10669] = {"Ground Scorpok Assay", "Ground Scorpok Assay", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[10692] = {"Cerebral Cortex Compound", "Cerebral Cortex Compound", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17538] = {"Elixir of the Mongoose", "Elixir of the Mongoose", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17539] = {"Greater Arcane Elixir", "Greater Arcane Elixir", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[26276] = {"Elixir of Greater Firepower", "Elixir of Greater Firepower", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[21920] = {"Elixir of Frost Power", "Elixir of Frost Power", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11474] = {"Elixir of Shadow Power", "Elixir of Shadow Power", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[24363] = {"Mageblood Potion", "Mageblood Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[24382] = {"Spirit of Zanza", "Spirit of Zanza", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[24383] = {"Swiftness of Zanza", "Swiftness of Zanza", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[24417] = {"Sheen of Zanza", "Sheen of Zanza", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17038] = {"Winterfall Firewater", "Winterfall Firewater", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[18192] = {"Grilled Squid", "Grilled Squid", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[18125] = {"Blessed Sunfruit", "Blessed Sunfruit", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[22730] = {"Runn Tum Tuber Surprise", "Runn Tum Tuber Surprise", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[18194] = {"Nightfin Soup", "Nightfin Soup", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[10256] = {"12 stam/spirit food", "12 stam/spirit food", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[25804] = {"Rumsey Rum Black Label", "Rumsey Rum Black Label", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[22790] = {"Kreeg's Stout Beatdown", "Kreeg's Stout Beatdown", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[22789] = {"Gordok Green Grog", "Gordok Green Grog", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[3593] = {"Elixir of Fortitude", "Elixir of Fortitude", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[3826] = {"Mighty Troll's Blood Potion", "Mighty Troll's Blood Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11348] = {"Elixir of Superior Defense", "Elixir of Superior Defense", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[12175] = {"Scroll of Protection IV", "Scroll of Protection IV", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[12179] = {"Scroll of Strength IV", "Scroll of Strength IV", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[12174] = {"Scroll of Agility IV", "Scroll of Agility IV", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[15233] = {"Crystal Ward", "Crystal Ward", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[15279] = {"Crystal Spire", "Crystal Spire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[5665] = {"Bogling Root", "Bogling Root", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[12608] = {"Catseye Elixir", "Catseye Elixir", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[15852] = {"Dragonbreath Chili", "Dragonbreath Chili", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11405] = {"Elixir of Giants", "Elixir of Giants", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11349] = {"Elixir of Greater Defense", "Elixir of Greater Defense", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11334] = {"Elixir of Greater Agility", "Elixir of Greater Agility", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16595] = {"Noggenfogger Elixir (Shrink)", "Noggenfogger Elixir (Shrink)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16591] = {"Noggenfogger Elixir (Skeleton)", "Noggenfogger Elixir (Skeleton)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16593] = {"Noggenfogger Elixir (Slow Fall)", "Noggenfogger Elixir (Slow Fall)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17540] = {"Greater Stoneshield Potion", "Greater Stoneshield Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[2379] = {"Swiftness Potion", "Swiftness Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[6615] = {"Free Action Potion", "Free Action Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[15822] = {"Dreamless Sleep Potion", "Dreamless Sleep Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[24364] = {"Living Action Potion", "Living Action Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[3169] = {"Limited Invulnerability Potion", "Limited Invulnerability Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17528] = {"Mighty Rage Potion", "Mighty Rage Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11359] = {"Restorative Potion", "Restorative Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11364] = {"Magic Resistance Potion", "Magic Resistance Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17548] = {"Greater Shadow Protection Potion", "Greater Shadow Protection Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17546] = {"Greater Nature Protection Potion", "Greater Nature Protection Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17544] = {"Greater Frost Protection Potion", "Greater Frost Protection Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17543] = {"Greater Fire Protection Potion", "Greater Fire Protection Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[17549] = {"Greater Arcane Protection Potion", "Greater Arcane Protection Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16325] = {"Juju Chill", "Juju Chill", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16326] = {"Juju Ember", "Juju Ember", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[11371] = {"Gift of Arthas", "Gift of Arthas", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[3219] = {"Weak Troll's Blood Potion", "Weak Troll's Blood Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[3222] = {"Strong Troll's Blood Potion", "Strong Troll's Blood Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[24361] = {"Major Troll's Blood Potion", "Major Troll's Blood Potion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[8221] = {"Savory Deviate Delight (Male Pirate)", "Savory Deviate Delight (Male Pirate)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[8222] = {"Savory Deviate Delight (Female Pirate)", "Savory Deviate Delight (Female Pirate)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[8220] = {"Savory Deviate Delight (Female Assassin)", "Savory Deviate Delight (Female Assassin)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[8219] = {"Savory Deviate Delight (Male Assassin)", "Savory Deviate Delight (Male Assassin)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[6405] = {"Dartol's Rod of Transformation", "Dartol's Rod of Transformation", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[22736] = {"Gordok Ogre Suit", "Gordok Ogre Suit", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		[16739] = {"Orb of Deception", "Orb of Deception", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CONSUMABLE, BCT.UNLISTED, BCT.UNRESERVED},
		-- World buffs
		[15366] = {GetSpellInfo(15366), "Songflower Serenade", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[22888] = {GetSpellInfo(22888), "Rallying Cry of the Dragonslayer", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[24425] = {GetSpellInfo(24425), "Spirit of Zandalar", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[29534] = {GetSpellInfo(29534), "Traces of Silithyst", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[16609] = {GetSpellInfo(16609), "Warchief's Blessing", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[22817] = {GetSpellInfo(22817), "Fengus' Ferocity", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[22820] = {GetSpellInfo(22820), "Slip'kik's Savvy", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[22818] = {GetSpellInfo(22818), "Mol'dar's Moxie", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[15288] = {GetSpellInfo(15288), "Fury of Ragnaros", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[15123] = {GetSpellInfo(15123), "Resist Fire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[17175] = {GetSpellInfo(17175), "Resist Arcane", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[16587] = {GetSpellInfo(16587), "Dark Whispers", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[17150] = {GetSpellInfo(17150), "Arcane Might", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.WORLDBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		-- Player buffs
		[9910] = {GetSpellInfo(9910), "Thorns", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10157] = {GetSpellInfo(10157), "Arcane Intellect", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[23028] = {GetSpellInfo(23028), "Arcane Brilliance", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10170] = {GetSpellInfo(10170), "Amplify Magic", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10174] = {GetSpellInfo(10174), "Dampen Magic", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10958] = {GetSpellInfo(10958), "Shadow Protection", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[27841] = {GetSpellInfo(27841), "Divine Spirit", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[27681] = {GetSpellInfo(27681), "Prayer of Spirit", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[6346] = {GetSpellInfo(6346), "Fear Ward", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[131] = {GetSpellInfo(131), "Water Breathing", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[546] = {GetSpellInfo(546), "Water Walking", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[5697] = {GetSpellInfo(5697), "Unending Breath", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[2970] = {GetSpellInfo(2970), "Detect Invisibility", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[132] = {GetSpellInfo(132), "Detect Lesser Invisibility", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[11743] = {GetSpellInfo(11743), "Detect Greater Invisibility", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[11551] = {GetSpellInfo(11551), "Battle Shout", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19740] = {GetSpellInfo(19740), "Blessing of Might", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20217] = {GetSpellInfo(20217), "Blessing of Kings", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[1038] = {GetSpellInfo(1038), "Blessing of Salvation", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19742] = {GetSpellInfo(19742), "Blessing of Wisdom", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19979] = {GetSpellInfo(19979), "Blessing of Light", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20914] = {GetSpellInfo(20914), "Blessing of Sanctuary", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10278] = {GetSpellInfo(10278), "Blessing of Protection", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[1044] = {GetSpellInfo(1044), "Blessing of Freedom", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20729] = {GetSpellInfo(20729), "Blessing of Sacrifice", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25782] = {GetSpellInfo(25782), "Greater Blessing of Might", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25898] = {GetSpellInfo(25898), "Greater Blessing of Kings", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25895] = {GetSpellInfo(25895), "Greater Blessing of Salvation", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25894] = {GetSpellInfo(25894), "Greater Blessing of Wisdom", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25890] = {GetSpellInfo(25890), "Greater Blessing of Light", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25899] = {GetSpellInfo(25899), "Greater Blessing of Sanctuary", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10293] = {GetSpellInfo(10293), "Devotion Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19746] = {GetSpellInfo(19746), "Concentration Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19900] = {GetSpellInfo(19900), "Fire Resistance Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19898] = {GetSpellInfo(19898), "Frost Resistance Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10299] = {GetSpellInfo(10299), "Retribution Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19896] = {GetSpellInfo(19896), "Shadow Resistance Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10441] = {GetSpellInfo(10441), "Strength of Earth", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10405] = {GetSpellInfo(10405), "Stoneskin", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10477] = {GetSpellInfo(10477), "Frost Resistance", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25360] = {GetSpellInfo(25360), "Grace of Air", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[8178] = {GetSpellInfo(8178), "Grounding Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10599] = {GetSpellInfo(10599), "Nature Resistance Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[25909] = {GetSpellInfo(25909), "Tranquil Air", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[15110] = {GetSpellInfo(15110), "Windwall Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10535] = {GetSpellInfo(10535), "Fire Resistance Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10461] = {GetSpellInfo(10461), "Healing Stream Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10494] = {GetSpellInfo(10494), "Mana Spring Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[17360] = {GetSpellInfo(17360), "Mana Tide Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20765] = {GetSpellInfo(20765), "Soulstone Resurrection", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[11767] = {GetSpellInfo(11767), "Blood Pact", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[19480] = {GetSpellInfo(19480), "Paranoia", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10060] = {GetSpellInfo(10060), "Power Infusion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20906] = {GetSpellInfo(20906), "Trueshot Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20190] = {GetSpellInfo(20190), "Aspect of the Wild", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[13159] = {GetSpellInfo(13159), "Aspect of the Pack", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[24932] = {GetSpellInfo(24932), "Leader of the Pack", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[24907] = {GetSpellInfo(24907), "Moonkin Aura", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[9863] = {GetSpellInfo(9863), "Tranquility", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[29166] = {GetSpellInfo(29166), "Innervate", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10929] = {GetSpellInfo(10929), "Renew", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[15359] = {GetSpellInfo(15359), "Inspiration", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[21564] = {GetSpellInfo(21564), "Prayer of Fortitude", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[10938] = {GetSpellInfo(10938), "Power Word: Fortitude", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[9841] = {GetSpellInfo(9841), "Rejuvenation", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[27637] = {GetSpellInfo(27637), "Regrowth", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[10901] = {GetSpellInfo(10901), "Power Word: Shield", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[9885] = {GetSpellInfo(9885), "Mark of the Wild", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[21850] = {GetSpellInfo(21850), "Gift of the Wild", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[552] = {GetSpellInfo(552), "Abolish Disease", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[14253] = {GetSpellInfo(14253), "Abolish Poison", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[11771] = {GetSpellInfo(11771), "Fire Shield", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[18264] = {GetSpellInfo(18264), "Headmaster's Charge", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[29203] = {GetSpellInfo(29203), "Healing Way", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[16237] = {GetSpellInfo(16237), "Ancestral Fortitude", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[27874] = {GetSpellInfo(27874), "Lightwell Renew", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[22009] = {GetSpellInfo(22009), "Greater Heal", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[28810] = {GetSpellInfo(28810), "Armor of Faith", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.RESERVED},
		[24597] = {GetSpellInfo(24597), "Furious Howl", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[7353] = {GetSpellInfo(7353), "Cozy Fire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[23060] = {GetSpellInfo(23060), "Battle Squawk", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		[20236] = {GetSpellInfo(20236), "Lay on Hands", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PLAYERBUFF, BCT.UNLISTED, BCT.UNRESERVED},
		-- Personals
		[23894] = {GetSpellInfo(23894), "Bloodthirst", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[12970] = {GetSpellInfo(12970), "Flurry", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[14204] = {GetSpellInfo(14204), "Enrage", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[29131] = {GetSpellInfo(29131), "Bloodrage", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[18499] = {GetSpellInfo(18499), "Berserker Rage", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[2565] = {GetSpellInfo(2565), "Shield Block", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[12292] = {GetSpellInfo(12292), "Sweeping Strikes", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[20230] = {GetSpellInfo(20230), "Retaliation", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[871] = {GetSpellInfo(871), "Shield Wall", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[1719] = {GetSpellInfo(1719), "Recklessness", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[12976] = {GetSpellInfo(12976), "Last Stand", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[16491] = {GetSpellInfo(16491), "Blood Craze", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		--[21890] = {GetSpellInfo(21890), "Warrior's Wrath", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[23547] = {GetSpellInfo(23547), "Parry", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[28846] = {GetSpellInfo(28846), "Cheat Death", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 1},

		[9634] = {GetSpellInfo(9634), "Dire Bear Form", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[768] = {GetSpellInfo(768), "Cat Form", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[24858] = {GetSpellInfo(24858), "Moonkin Form", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[5229] = {GetSpellInfo(5229), "Enrage", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[16864] = {GetSpellInfo(16864), "Omen of Clarity", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[16870] = {GetSpellInfo(16870), "Clearcasting", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[22812] = {GetSpellInfo(22812), "Barkskin", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[22896] = {GetSpellInfo(22896), "Frenzied Regeneration", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[13494] = {"Manual Crowd Pummeler", "Haste", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[17116] = {GetSpellInfo(17116), "Nature's Swiftness", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[16886] = {GetSpellInfo(16886), "Nature's Grace", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 11},

		--https://classic.wowhead.com/spell=19578/spirit-bond
		--https://classic.wowhead.com/spell=1495/mongoose-bite
		--https://classic.wowhead.com/spell=19306/counterattack
		[1515] = {GetSpellInfo(1515), "Tame Beast", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[1002] = {GetSpellInfo(1002), "Eyes of the Beast", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[3045] = {GetSpellInfo(3045), "Rapid Fire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[5384] = {GetSpellInfo(5384), "Feign Death", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[6150] = {GetSpellInfo(6150), "Quick Shots", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[19263] = {GetSpellInfo(19263), "Deterrence", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[14322] = {GetSpellInfo(14322), "Aspect of the Hawk", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[13163] = {GetSpellInfo(13163), "Aspect of the Monkey", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[5118] = {GetSpellInfo(5118), "Aspect of the Cheetah", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},
		[13161] = {GetSpellInfo(13161), "Aspect of the Beast", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 3},

		[12042] = {GetSpellInfo(12042), "Arcane Power", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[22783] = {GetSpellInfo(22783), "Mage Armor", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[10220] = {GetSpellInfo(10220), "Ice Armor", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[1953] = {GetSpellInfo(1953), "Blink", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[12536] = {GetSpellInfo(12536), "Clearcasting", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[28682] = {GetSpellInfo(28682), "Combustion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[10225] = {GetSpellInfo(10225), "Fire Ward", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED, 8},
		[28609] = {GetSpellInfo(28609), "Frost Ward", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED, 8},
		[13033] = {GetSpellInfo(13033), "Ice Barrier", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED, 8},
		[11958] = {GetSpellInfo(11958), "Ice Block", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED, 8},
		[10193] = {GetSpellInfo(10193), "Mana Shield", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED, 8},
		[12043] = {GetSpellInfo(12043), "Presence of Mind", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},
		[130] = {GetSpellInfo(130), "Slow Fall", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 8},

		[27818] = {GetSpellInfo(27818), "Blessed Recovery", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[15271] = {GetSpellInfo(15271), "Spirit Tap", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[14743] = {GetSpellInfo(14743), "Focused Casting", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[19293] = {GetSpellInfo(19293), "Elune's Grace", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[10942] = {GetSpellInfo(10942), "Fade", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[19275] = {GetSpellInfo(19275), "Feedback", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[10952] = {GetSpellInfo(10952), "Inner Fire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[1706] = {GetSpellInfo(1706), "Levitate", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[19312] = {GetSpellInfo(19312), "Shadowguard", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[19266] = {GetSpellInfo(19266), "Touch of Weakness", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[14751] = {GetSpellInfo(14751), "Inner Focus", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[15473] = {GetSpellInfo(15473), "Shadowform", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[21976] = {GetSpellInfo(21976), "Reactive Fade", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[28804] = {GetSpellInfo(28804), "Epiphany", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},

		--https://classic.wowhead.com/spell=14251/riposte
		[6774] = {GetSpellInfo(6774), "Slice and Dice", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[13877] = {GetSpellInfo(13877), "Blade Flurry", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[13750] = {GetSpellInfo(13750), "Adrenaline Rush", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[5277] = {GetSpellInfo(5277), "Evasion", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[11305] = {GetSpellInfo(11305), "Sprint", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[1787] = {GetSpellInfo(1787), "Stealth", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[1857] = {GetSpellInfo(1857), "Vanish", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[18461] = {GetSpellInfo(18461), "Vanish Purge", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[14177] = {GetSpellInfo(14177), "Cold Blood", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[14278] = {GetSpellInfo(14278), "Ghostly Strike", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		[23580] = {GetSpellInfo(23580), "Bloodfang", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		--[28814] = {GetSpellInfo(28814), "Revealed Flaw", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 4},
		
		[16246] = {GetSpellInfo(16246), "Clearcasting", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[29063] = {GetSpellInfo(29063), "Focused Casting", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[16166] = {GetSpellInfo(16166), "Elemental Mastery", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[16280] = {GetSpellInfo(16280), "Flurry", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[16188] = {GetSpellInfo(16188), "Nature's Swiftness", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		--[26119] = {GetSpellInfo(26119), "Stormcaller Spelldamage Bonus", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[6196] = {GetSpellInfo(6196), "Far Sight", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[2645] = {GetSpellInfo(2645), "Ghost Wolf", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[10432] = {GetSpellInfo(10432), "Lightning Shield", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		[6495] = {GetSpellInfo(6495), "Sentry Totem", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 7},
		
		--https://classic.wowhead.com/spell=17949/firestone-passive
		--https://classic.wowhead.com/spell=23720/blessing-of-the-black-book
		--https://classic.wowhead.com/spell=21922/demonic-ally
		--https://classic.wowhead.com/spell=21741/demonic-ally
		[11735] = {GetSpellInfo(11735), "Demon Armor", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[696] = {GetSpellInfo(696), "Demon Skin", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[28610] = {GetSpellInfo(28610), "Shadow Ward", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[17730] = {GetSpellInfo(17730), "Major Spellstone", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[19443] = {GetSpellInfo(19443), "Sacrifice", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED, 9},
		[11695] = {GetSpellInfo(11695), "Health Funnel", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[11684] = {GetSpellInfo(11684), "Hellfire", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[126] = {GetSpellInfo(126), "Eye of Kilrogg", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[25228] = {GetSpellInfo(25228), "Soul Link", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[23829] = {GetSpellInfo(23829), "Master Demonologist", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[18789] = {GetSpellInfo(18789), "Burning Wish", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[18790] = {GetSpellInfo(18790), "Fel Stamina", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[18791] = {GetSpellInfo(18791), "Touch of Shadow", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[18792] = {GetSpellInfo(18792), "Fel Energy", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[18288] = {GetSpellInfo(18288), "Amplify Curse", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[1120] = {GetSpellInfo(1120), "Drain Soul", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[18371] = {GetSpellInfo(18371), "Soul Siphon", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},
		[17941] = {GetSpellInfo(17941), "Shadow Trance", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 9},

		[20572] = {GetSpellInfo(20572), "Blood Fury", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[20554] = {GetSpellInfo(20554), "Berserking", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[7744] = {GetSpellInfo(7744), "Will of the Forsaken", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[20580] = {GetSpellInfo(20580), "Shadowmeld", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[20594] = {GetSpellInfo(20594), "Stoneform", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[20600] = {GetSpellInfo(20600), "Perception", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[2479] = {GetSpellInfo(2479), "Honorless Target", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[1131] = {"Eating Food (45)", "Eating Food (45)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[22734] = {"Drinking Water (55)", "Drinking Water (55)", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[23132] = {GetSpellInfo(23132), "Shadow Reflector", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[23097] = {GetSpellInfo(23097), "Fire Reflector", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[23131] = {GetSpellInfo(23131), "Frost Reflector", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED},
		[26470] = {GetSpellInfo(26470), "Persistent Shield", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.RESERVED},
		[24546] = {GetSpellInfo(24546), "Rapid Healing", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
		[24546] = {GetSpellInfo(24546), "Rapid Healing", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PERSONALS, BCT.UNLISTED, BCT.UNRESERVED, 5},
	},
	[BCT.ENCHANT] = {
		[1510] = {"Spirit +8", "Spirit +8", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1507] = {"Stamina +8", "Stamina +8", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1504] = {"Armor +125", "Armor +125", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[2545] = {"Dodge +1%", "Dodge +1%", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1483] = {"Mana +150", "Mana +150", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1506] = {"Strength +8", "Strength +8", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1509] = {"Intellect +8", "Intellect +8", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1503] = {"HP +100", "HP +100", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[2543] = {"Attack Speed +1%", "Attack Speed +1%", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1505] = {"+20 Fire Resistance", "+20 Fire Resistance", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1508] = {"Agility +8", "Agility +8", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[2544] = {"Healing and Spell Damage +8", "Healing and Spell Damage +8", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[464] = {"Mithril Spurs", "Mithril Spurs", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[1704] = {"Thorium Spike", "Thorium Spike", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[2506] = {"Elemental Sharpening Stone", "Elemental Sharpening Stone", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
		[34] = {"Counterweight", "Counterweight", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.ENCHANT, BCT.UNLISTED, BCT.UNRESERVED},
	},
	[BCT.OTHER] = {
		[1] = {"Defensive State", "Defensive State", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CLASS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[2] = {"Stance", "Stance", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.CLASS, BCT.UNLISTED, BCT.UNRESERVED, 1},
		[3] = {"Tracking", "Tracking", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.PROFESSION, BCT.UNLISTED, BCT.UNRESERVED},
		[4] = {"Predatory Strikes", "Predatory Strikes", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.TALENT, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[5] = {"Furor", "Furor", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.TALENT, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[6] = {"Heart of the Wild", "Heart of the Wild", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.TALENT, BCT.UNLISTED, BCT.UNRESERVED, 11},
		[7] = {"Elemental Devastation", "Elemental Devastation", BCT.HIDE, BCT.COUNT, BCT.WHITELISTED, BCT.TALENT, BCT.UNLISTED, BCT.UNRESERVED, 7},
	},
	[BCT.DEBUFF] = {
		[8733] = {GetSpellInfo(8733), "Blessing of Blackfathom", BCT.HIDE, BCT.IGNORE, BCT.WHITELISTED, BCT.DEBUFF, BCT.UNLISTED, BCT.UNRESERVED},
	},
}

local defaults = {
	profile = {
		window = {
			enable = true,
			lock = false,
			anchor = {
				font = "Expressway",
				font_size = 16,
				font_style = "OUTLINE",
				value = "BUFF CAP TRACKER",
				counter = "None",
				x_offset = 0,
				y_offset = 0,
				width = 200,
				height = 35,
				clickthrough = false,
			},
			body = {
				font = "Expressway",
				font_size = 13,
				font_style = "OUTLINE",
				mouseover = false,
				growup = false,
				group_lines = false,
				x_offset = 0,
				y_offset = 0,
				width = 200,
				height = 35,
			},
			text = {
				["enchants"] = false,
				["buffs"] = true,
				["nextone"] = true,
				["tracking"] = true,
				["nextfive"] = false,
				["profile"] = false,
			},
		},
		loading = {
			groupState = {
				["Solo"] = true,
				["Group"] = true,
				["Raid"] = true,
				["Battleground"] = true,
			},
			instanceState = {
				[0] = true,
				[5] = true,
				[10] = true,
				[20] = true,
				[40] = true,
			},
			enabled = true,
			groupStateBL = {
				["Solo"] = true,
				["Group"] = true,
				["Raid"] = true,
				["Battleground"] = true,
			},
			instanceStateBL = {
				[0] = true,
				[5] = true,
				[10] = true,
				[20] = true,
				[40] = true,
			},
			enabledBL = true,
			groupStateAnn = {
				["Solo"] = true,
				["Group"] = true,
				["Raid"] = true,
				["Battleground"] = true,
			},
			instanceStateAnn = {
				[0] = true,
				[5] = true,
				[10] = true,
				[20] = true,
				[40] = true,
			},
			enabledAnn = true,
			groupStateFrames = {
				["Solo"] = true,
				["Group"] = true,
				["Raid"] = true,
				["Battleground"] = true,
			},
			instanceStateFrames = {
				[0] = true,
				[5] = true,
				[10] = true,
				[20] = true,
				[40] = true,
			},
			enabledFrames = true,
			groupStateHl = {
				["Solo"] = true,
				["Group"] = true,
				["Raid"] = true,
				["Battleground"] = true,
			},
			instanceStateHl = {
				[0] = true,
				[5] = true,
				[10] = true,
				[20] = true,
				[40] = true,
			},
			enabledHl = true,
		},
		announcer = {
			font = "Expressway",
			font_size = 40,
			font_style = "OUTLINE",
			enabledBl = false,
			enabledTrck = false,
		},
		blacklisting = {
			enabledOut = false,
			enabledIn = false,
			buffer = 2,
		},
		highlighter = {
			enabled = false,
			enabledCap = false,
			buffer = 2,
			cap = 30,
			glowColorCap = {1,0,0},
			glowColor = {1,0.45,0},
			glowParticles = 20,
			glowFrequency = 0.2,
			glowLength = 2,
			glowThickness = 2,
			glowxOffset = 2,
			glowyOffset = 2,
			glowBorder = true,
			glowScale = 3.75,
			rangeCheckFreq = 1,
		},
		auras = auras_default
	}
}

-- Init Session
BCT.session = {}

-- Init Profile
function BCT:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BCTDB", defaults, true)
	self.session.db = self.db.profile
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
end

function BCT:RefreshConfig()
	self.session.db = self.db.profile
	self.Refresh()
	self.UpdateFont()
	self.UpdateFontAnnouncer()
	self.UpdateWindowState()
	self.SetInCombatBlacklistingMacro()
	self.profileStr = self.db:GetCurrentProfile()
end

-- Events
BCT.Events = CreateFrame("Frame","BCTEvents",UIParent)

-- Init Session State
BCT.session.state = {
	aurasSourceSelected = 0,
	aurasTypeSelected = 1,
	aurasSearch = "",
	aurasFilter = "all",
	aurasCounter = 0,
	CombatCache = false,
	DefensiveState = false,
	macros = "",
	cleanedup = false,
	zone = GetInstanceInfo(),
	reservedBuffs = {},
	raid = {},
	rangeCheck = {},
}

BCT.items = {}
BCT.buffs = {}
BCT.hidden = {}
BCT.aurasSorted = {}
BCT.nextAura = "                 "
BCT.nextAuraId = 0
BCT.buffsTotal = 0
BCT.enchantsTotal = 0
BCT.hiddenTotal = 0
BCT.aurasMax = 0
BCT.enchantsPushed = 0
BCT.trackedStr = ""
BCT.enchantsStr = ""
BCT.buffStr = ""
BCT.nextFiveStr = ""
BCT.profileStr = ""
BCT.optionsFrames = {}